Index: /trunk/SophyaPI/PI/piwdggen.cc
===================================================================
--- /trunk/SophyaPI/PI/piwdggen.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/piwdggen.cc	(revision 4083)
@@ -57,7 +57,4 @@
 //--
 //++
-// void  PSPrint(PSFile *psf, int ofx=0, int ofy=0)
-//	Méthode virtuelle qui doit être redéfinie pour chacune des classes filles.
-//	produit une représentation graphique de l'objet en Postscript.
 // SetSize(int sx, int sy)
 //	Modifie la taille de l'objet.
@@ -181,4 +178,16 @@
 // int  UserFlag()
 //	Renvoie la valeur "int" user de l'objet.
+//--
+
+//++
+// Titre	Export postscript et format RGB
+//--
+//++
+// void  PSPrint(PSFile *psf, int ofx=0, int ofy=0)
+//	Méthode virtuelle qui doit être redéfinie pour chacune des classes filles.
+//	produit une représentation graphique de l'objet en Postscript.
+// void  ExportToRGB(PIPixRGBArray & rgba)
+//	Méthode virtuelle qui doit être redéfinie pour chaque architecture.
+//	Remplit un tableau PIPixRGBArray le contenu pixels du widget en couleurs RGB. 
 //--
 
@@ -309,4 +318,10 @@
 }
 
+/* --Methode-- */
+void PIWdgGen::ExportToRGB(PIPixRGBArray & rgba)
+{
+return;
+}
+
 //++
 // Titre	Gestion des Draw/Event Handler
Index: /trunk/SophyaPI/PI/piwdggen.h
===================================================================
--- /trunk/SophyaPI/PI/piwdggen.h	(revision 4082)
+++ /trunk/SophyaPI/PI/piwdggen.h	(revision 4083)
@@ -10,4 +10,5 @@
 #include "pimsghandler.h"
 #include "picolist.h"
+#include "pipixutils.h"
 
 #include <string>
@@ -107,6 +108,10 @@
   virtual bool           IfSensitive()=0;
 
+//  Pour exporter le contenu d'un widget (dessin vectoriel) en postscript
   virtual void           PSPrint(PSFile *psf, int ofx=0, int ofy=0,
 				 double scale_x=1., double scale_y=1.);
+// Pour exporter le tableau des pixels du widget en classe  PIPixRGBArray
+// L'implementation par defaut ne fait rien 
+  virtual void           ExportToRGB(PIPixRGBArray & rgba);
 
 //  Gestion de copier-coller
Index: /trunk/SophyaPI/PI/piwdgx.cc
===================================================================
--- /trunk/SophyaPI/PI/piwdgx.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/piwdgx.cc	(revision 4083)
@@ -20,9 +20,5 @@
 #include "pigraphx.h"
 
-#ifdef SANS_EVOLPLANCK
-#include "perrors.h"
-#else
 #include "pexceptions.h"
-#endif
 
 
@@ -50,4 +46,5 @@
 szx = appSzX;  szy = appSzY;
 szf = appSzFont;
+ printf("XtAppContext* PIXtAppCtx :szx=%d szy=%d szf=%d",szx,szy,szf);
 return(&appctx);
 }
@@ -627,30 +624,30 @@
 // Ressources X si non definis 
 static const String fallback_res[26] = {
-"PeidaInt*default*background:                 LightGrey" ,
-"PeidaInt*background:                         LightGrey" ,
-"PeidaInt*Foreground:                         Black",
-"PeidaInt*default*Foreground:                 Black",
-"PeidaInt*default*bottomShadowColor:          Black",
-"PeidaInt*bottomShadowColor:                  Black",
-"PeidaInt*default*topShadowColor:             White",
-"PeidaInt*topShadowColor:                     White",
-"PeidaInt*borderColor:                        Black",
-"PeidaInt*XmLabel.borderWidth:                0",
-"PeidaInt*XmDrawingArea*background:           Black",
-"PeidaInt*XmPushButton*borderWidth:           0",
-"PeidaInt*XmText*shadowThickness:             2",
-"PeidaInt*XmText*highlightThickness:          0",
-"PeidaInt*XmText*marginHeigt:                 0",
-"PeidaInt*XmText*marginWidth:                 2",
-// "PeidaInt*DefMenubar*XtNwidth:                250",
-// "PeidaInt*DefMenubar*XtNheight:               30",
-"PeidaInt*fontList:           -*-courier-bold-r-normal-*-12-*-*-*-*-*-ISO8859-1",
-"PeidaInt*default*fontList:   -*-courier-bold-r-normal-*-12-*-*-*-*-*-ISO8859-1",
-"PeidaInt*fontFamilyName:                     *-courier",    // Pas de blanc apres le nom de font
-"PeidaInt*courierfontFamilyName:              *-courier",    //           "        " 
-"PeidaInt*helveticafontFamilyName:            *-helvetica",  //           "        " 
-"PeidaInt*timesfontFamilyName:                *-times",      //           "        " 
-"PeidaInt*symbolfontFamilyName:               *-symbol",     //           "        " 
-"PeidaInt*XmToggleButton*selectColor:         Red",
+const_cast<char*>("PeidaInt*default*background:                 LightGrey") ,
+const_cast<char*>("PeidaInt*background:                         LightGrey") ,
+const_cast<char*>("PeidaInt*Foreground:                         Black"),
+const_cast<char*>("PeidaInt*default*Foreground:                 Black"),
+const_cast<char*>("PeidaInt*default*bottomShadowColor:          Black"),
+const_cast<char*>("PeidaInt*bottomShadowColor:                  Black"),
+const_cast<char*>("PeidaInt*default*topShadowColor:             White"),
+const_cast<char*>("PeidaInt*topShadowColor:                     White"),
+const_cast<char*>("PeidaInt*borderColor:                        Black"),
+const_cast<char*>("PeidaInt*XmLabel.borderWidth:                0"),
+const_cast<char*>("PeidaInt*XmDrawingArea*background:           Black"),
+const_cast<char*>("PeidaInt*XmPushButton*borderWidth:           0"),
+const_cast<char*>("PeidaInt*XmText*shadowThickness:             2"),
+const_cast<char*>("PeidaInt*XmText*highlightThickness:          0"),
+const_cast<char*>("PeidaInt*XmText*marginHeigt:                 0"),
+const_cast<char*>("PeidaInt*XmText*marginWidth:                 2"),
+// const_cast<char*>("PeidaInt*DefMenubar*XtNwidth:                250"),
+// const_cast<char*>("PeidaInt*DefMenubar*XtNheight:               30"),
+const_cast<char*>("PeidaInt*fontList:           -*-courier-bold-r-normal-*-12-*-*-*-*-*-ISO8859-1"),
+const_cast<char*>("PeidaInt*default*fontList:   -*-courier-bold-r-normal-*-12-*-*-*-*-*-ISO8859-1"),
+const_cast<char*>("PeidaInt*fontFamilyName:                     *-courier"),    // Pas de blanc apres le nom de font
+const_cast<char*>("PeidaInt*courierfontFamilyName:              *-courier"),    //           "        " 
+const_cast<char*>("PeidaInt*helveticafontFamilyName:            *-helvetica"),  //           "        " 
+const_cast<char*>("PeidaInt*timesfontFamilyName:                *-times"),      //           "        " 
+const_cast<char*>("PeidaInt*symbolfontFamilyName:               *-symbol"),     //           "        " 
+const_cast<char*>("PeidaInt*XmToggleButton*selectColor:         Red"),
 NULL
 };
@@ -681,18 +678,10 @@
 if (top == NULL) {
   fprintf(stderr, "PIWdgX::InitXt()/ Error XtVaAppInitialize()\n");
-#ifdef SANS_EVOLPLANCK
-  throw notFoundErr;
-#else
-  throw NotFoundExc("PIWdgX::InitXt()/ Error XtVaAppInitialize()");
-#endif
+  throw PError("PIWdgX::InitXt()/ Error XtVaAppInitialize()");
   }
 dpy = XtDisplay(top);
 if (dpy == NULL)  {
   fprintf(stderr, "PIWdgX::InitXt()/ Error XtVaAppInitialize()/DisplayConnection\n");
-#ifdef SANS_EVOLPLANCK
-  throw notFoundErr;
-#else
-  throw NotFoundExc("PIWdgX::InitXt()/ Error XtVaAppInitialize()/DisplayConnection");
-#endif
+  throw PError("PIWdgX::InitXt()/ Error XtVaAppInitialize()/DisplayConnection");
   }
 
@@ -734,5 +723,5 @@
   }
 stdfnt = XLoadQueryFont(dpy, buff);
-char * myfntname = "???";
+const char * myfntname = "???";
 // Recherche du champ taille en pixel de la fonte : apres le 7eme tiret
 int mySzFont = 12;
@@ -831,4 +820,56 @@
 }
 
+
+// Pour exporter le tableau des pixels du widget en classe  PIPixRGBArray
+inline void _col2_fcol_(unsigned long & col, unsigned long & fcol)
+{
+  if (col > 0x00FFFFFF)  fcol = 0x01000000;
+  else if  (col > 0x0000FFFF)  fcol = 0x000010000;
+  else if (col > 0x000000FF) fcol = 0x00000100;
+  else fcol = 1;  
+}   
+/* --Methode-- */
+void PIWdgX::ExportToRGB(PIPixRGBArray & rgba)
+{
+Display* mdsp = PIXDisplay();
+int scr = XDefaultScreen(mdsp);
+int depth = DefaultDepth(mdsp,scr);
+Window xw = XtWindow(XtWdg());
+unsigned long plane_mask = ~0;  // tous les bits a 1
+XImage * ximg = XGetImage(mdsp, xw, 0, 0, XSize(), YSize(), plane_mask, ZPixmap);
+//DBG  cout << " Resultat XGetImage -> " << hex << ximg << dec << endl;
+if (ximg == NULL)  return;	
+                            
+unsigned long red,green,blue;
+unsigned long fred,fgreen,fblue;
+XColor col;
+Colormap  cmap = XDefaultColormap (mdsp, scr);
+red = 0x000000FF; 
+green = 0x0000FF00;
+blue = 0x00FF0000;
+unsigned short maxrgb = ~0;
+col.red = maxrgb;  col.green = col.blue = 0;
+if (XAllocColor(mdsp, cmap, &col)) red = col.pixel; 
+col.green = maxrgb;  col.red = col.blue = 0;
+if (XAllocColor(mdsp, cmap, &col)) green = col.pixel;      
+col.blue = maxrgb;  col.red = col.green = 0;
+if (XAllocColor(mdsp, cmap, &col)) blue = col.pixel;      
+_col2_fcol_(red, fred);
+_col2_fcol_(green, fgreen);
+_col2_fcol_(blue, fblue);
+rgba.SetSize(XSize(), YSize());
+unsigned long pixel;
+PIPixRGB rgb;
+for(int j=0; j<YSize(); j++)
+  for(int i=0; i<XSize(); i++) {
+    pixel = XGetPixel(ximg, i, j);
+    rgb.red = (pixel&red)/fred;
+    rgb.green = (pixel&green)/fgreen;
+    rgb.blue = (pixel&blue)/fblue;
+    rgba(i,j) = rgb;
+  }
+  XDestroyImage(ximg);
+  return;  
+}
 
 
Index: /trunk/SophyaPI/PI/piwdgx.h
===================================================================
--- /trunk/SophyaPI/PI/piwdgx.h	(revision 4082)
+++ /trunk/SophyaPI/PI/piwdgx.h	(revision 4083)
@@ -63,4 +63,7 @@
   virtual void           SetUnSensitive();
   virtual bool           IfSensitive();
+
+// Pour exporter le tableau des pixels du widget en classe  PIPixRGBArray
+  virtual void           ExportToRGB(PIPixRGBArray & rgba);
 
 //  Gestion de copier-coller
Index: /trunk/SophyaPI/PI/piwindowx.cc
===================================================================
--- /trunk/SophyaPI/PI/piwindowx.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/piwindowx.cc	(revision 4083)
@@ -152,7 +152,9 @@
 //if (mWtyp == PIWK_transient)  
   XRaiseWindow(mdsp, XtWindow(pwm->XtWdg()));
+  // cmv+rz Fevrier 2009 (retour Moriond) - Suppression de XFlush() / usleep  
+  // Probleme regle par gestion VisibilityChange event ds pixtbase.cc
   // cmv+rz 09/08/2007 Ajout XFlush() + usleep 
   // pour regler le probleme de  perte d'evenement expose a la creation
-  XFlush(mdsp);   usleep(5000);
+  //  XFlush(mdsp);   usleep(5000);
 return;
 }
Index: /trunk/SophyaPI/PI/pixtbase.cc
===================================================================
--- /trunk/SophyaPI/PI/pixtbase.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/pixtbase.cc	(revision 4083)
@@ -46,5 +46,5 @@
 
 static XtResource resources[] ={
-  {PIXNobject ,(char *)"Object", XtRPointer, sizeof(XtRPointer),
+  {const_cast<char*>(PIXNobject) ,const_cast<char*>("Object"), XtRPointer, sizeof(XtRPointer),
    XtOffset(PIXtBaseWidget,  pixtbase.objet), XtRImmediate, (XtPointer)0},
 };
@@ -143,4 +143,24 @@
 }
 
+// Pour traiter les etats de changements de visibilite de la fenetre
+/* Nouvelle-Fonction */
+void visibchange_handler_pixtbase (Widget wdgp, XtPointer /*closure*/, 
+                             XEvent* evt, Boolean* cont)
+{
+#ifdef DEBUG_PIXTB
+printf("Debug_visibchange_handler_pixtbase: Wdg= %lx Object= %lx  fgvis_expose= %d (EvtType=%d VisSt=%d)\n", 
+  (long)wdgp, (long)(((PIXtBaseWidget)wdgp)->pixtbase.objet),
+  ((PIXtBaseWidget)wdgp)->pixtbase.vis_expose_fg, (int)evt->type,(int)evt->xvisibility.state);
+#endif
+PIXtBaseWidget bwdg = (PIXtBaseWidget)wdgp;
+if (bwdg->pixtbase.vis_expose_fg != 1) return;
+if (evt->xvisibility.state == VisibilityFullyObscured)  return;
+int x0, y0, dx, dy;
+x0 = y0 = 0;
+dx = wdgp->core.width;  dy = wdgp->core.height;
+(bwdg->pixtbase.objet)->eXposeProcess(x0, y0, dx, dy);
+bwdg->pixtbase.vis_expose_fg = 0;
+}
+
 /* Nouvelle-Fonction */
 static void init_pixtbase (Widget request, Widget wdg,
@@ -154,12 +174,16 @@
 // get_GCs (wdgp);
 #ifdef DEBUG_PIXTB
-printf("Debug_init_pixtbase: Wdg=%lx Object= %lx  narg=%d \n", 
-(long)wdgp, (long)(wdgp->pixtbase.objet), (int)(*narg));
-#endif
-return;
-}
-
-/* Nouvelle-Fonction */
-static void destroy_pixtbase (Widget /*wdgp*/)
+printf("Debug_init_pixtbase: Wdg=%lx Object= %lx  \n", 
+(long)wdgp, (long)(wdgp->pixtbase.objet));
+#endif
+
+// Pour gerer les exposes event avec fenetre non visible ...
+wdgp->pixtbase.vis_expose_fg = 0;
+XtAddEventHandler(wdg, VisibilityChangeMask, FALSE, visibchange_handler_pixtbase, NULL);
+return;
+}
+
+/* Nouvelle-Fonction */
+static void destroy_pixtbase (Widget wdgp)
 {
 #ifdef DEBUG_PIXTB
@@ -194,14 +218,23 @@
 (long)(((PIXtBaseWidget)wdgp)->pixtbase.objet) );
 #endif
-if (!(wdgp->core.visible))  return;
-if ( ((PIXtBaseWidget)wdgp)->pixtbase.objet ) 
-  {
+if (!(wdgp->core.visible))  { 
+  ((PIXtBaseWidget)wdgp)->pixtbase.vis_expose_fg = 1;
+  return;
+}
+if ( ((PIXtBaseWidget)wdgp)->pixtbase.objet ) {
   XRectangle  xrec;
   int x0, y0, dx, dy;
-  XClipBox(region, &xrec);
-  x0 = xrec.x;  y0 = xrec.y;
-  dx = xrec.width;  dy = xrec.height;
+  if (region) {
+    XClipBox(region, &xrec);
+    x0 = xrec.x;  y0 = xrec.y;
+    dx = xrec.width;  dy = xrec.height;
+  }
+  else {
+    x0 = y0 = 0;
+    dx = wdgp->core.width;  dy = wdgp->core.height;
+  }
   (((PIXtBaseWidget)wdgp)->pixtbase.objet)->eXposeProcess(x0, y0, dx, dy);
-  }
+  ((PIXtBaseWidget)wdgp)->pixtbase.vis_expose_fg = 0;
+}
 return;
 }
Index: /trunk/SophyaPI/PI/pixtbaseP.h
===================================================================
--- /trunk/SophyaPI/PI/pixtbaseP.h	(revision 4082)
+++ /trunk/SophyaPI/PI/pixtbaseP.h	(revision 4083)
@@ -24,4 +24,5 @@
 PIBaseWdgX  * objet; 
 unsigned long myeventmask;
+unsigned int vis_expose_fg;   // Gestion des expose_event avec fenetre non visible
 } PIXtBasePart;
 
Index: /trunk/SophyaPI/PI/psfile.cc
===================================================================
--- /trunk/SophyaPI/PI/psfile.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/psfile.cc	(revision 4083)
@@ -682,5 +682,5 @@
 	}
 	/* Portrait ou Landscape ? */
-	if(orientation == PI_Auto) 
+	if(orientation == PI_Auto)  {
 	    if( ((tw < th) && (Dx < 1.2*Dy)) ||
 		((tw > th) && (Dx > Dy) )) 
@@ -688,5 +688,5 @@
 	    else 
 		currentPage->orientation = PI_Landscape ;
-
+	}
 	if(currentPage->orientation == PI_Portrait) {
 	  //	    if( (tw/Dx) < (th/Dy) ) 
@@ -1367,6 +1367,46 @@
     for(i = 0; i < Ny; i++) {
 	for(j = 0; j<Nx-1; j++ )
-	    fprintf(mPSFile, "%02X", Pict[i*Nx+j]);
-    fprintf(mPSFile, "%02X\n", Pict[i*Nx+j]);
+	    fprintf(mPSFile, "%02X", (int)Pict[i*Nx+j]);
+    fprintf(mPSFile, "%02X\n", (int)Pict[i*Nx+j]);
+    }
+    /* Un petit grestore ...*/
+    fprintf(mPSFile, "gr\n");
+}
+
+void PSFile::Image(double x0, double y0, double Tx, double Ty,
+		   int Nx, int Ny,
+		   unsigned short *Pict, 
+		   PIColorMap *mMap) {
+
+    int i, j;
+
+    /* Buffers PostScript */
+    fprintf(mPSFile, "/Taille %d def\n", Nx);
+    fprintf(mPSFile, "/ImStr Taille string def\n");
+    fprintf(mPSFile, "/RGBStr Taille 3  mul string def\n");
+
+    /* Ecriture ColorMap */
+    fprintf(mPSFile, "/ColorMap %05d array def\n", mMap->NCol() );
+    for(i = 0; i < mMap->NCol(); i++) {
+	fprintf(mPSFile, "ColorMap %d [16#%02X 16#%02X 16#%02X] put\n",
+		i,
+		(int)(mMap->GetColor(i).red/256),
+		(int)(mMap->GetColor(i).green/256),
+		(int)(mMap->GetColor(i).blue/256));
+    }
+    /* Emplacement de l'image */
+    fprintf(mPSFile, "gs %.2f Ux %.2f Uy tr %.2f Ux %.2f Uy sc\n", x0, y0, Tx, Ty);
+    /* Nbr pix-X, Nbr pix-Y bits/pixels */
+    fprintf(mPSFile, "%d %d 16\n", Nx, Ny);
+    /* Matrice de passage */
+    fprintf(mPSFile, "[%d 0 0 %d 0 0]", Nx, Ny);
+    /* Fonction colorimage */
+    fprintf(mPSFile, "{currentfile ImStr readhexstring pop GetRGB}\
+false 3 colorimage\n\n");
+    /* Data */
+    for(i = 0; i < Ny; i++) {
+	for(j = 0; j<Nx-1; j++ )
+	    fprintf(mPSFile, "%04X", (int)Pict[i*Nx+j]);
+    fprintf(mPSFile, "%04X\n", (int)Pict[i*Nx+j]);
     }
     /* Un petit grestore ...*/
Index: /trunk/SophyaPI/PI/psfile.h
===================================================================
--- /trunk/SophyaPI/PI/psfile.h	(revision 4082)
+++ /trunk/SophyaPI/PI/psfile.h	(revision 4083)
@@ -165,4 +165,8 @@
 			unsigned char *pict,
 			PIColorMap *mColorMap);
+    virtual void  Image(double x0, double y0, double Tx, double Ty,
+			int Nx, int Ny,
+			unsigned short *pict,
+			PIColorMap *mColorMap);
 
 // Declarations en public - sinon certains compilateurs cxx , aCC, xlC ont des problemes
